freeslot("S_PLAY_SLAM","S_PLAY_SPINJUMP",
"sfx_ptslam","sfx_ptstsl","sfx_swsjmp","sfx_kmspin","sfx_kmwkik","sfx_kwskid","sfx_kswtch","sfx_m64unh","sfx_m64doh","sfx_m64oof","sfx_kmbip0","sfx_kmbip1",
"MT_S3INSTASHIELD","S_S3INSTASHIELD","S_S3INSTASHIELD1","S_S3INSTASHIELD2","S_S3INSTASHIELD3","S_S3INSTASHIELD4","S_S3INSTASHIELD5",
"SPR_S3IS")

states[S_PLAY_SLAM] = {
	sprite = SPR_PLAY,
	frame = SPR2_SLAM,
	tics = -1,
	nextstate = S_PLAY_SLAM,
}
states[S_PLAY_SPINJUMP] = {
	sprite = SPR_PLAY,
	frame = SPR2_STND,
	tics = -1,
	nextstate = S_PLAY_SPINJUMP,
}

mobjinfo[MT_S3INSTASHIELD] = {
	doomednum = -1,
	dispoffset = 1,
	spawnhealth = 1,
	spawnstate = S_S3INSTASHIELD,
	radius = 36*FRACUNIT,
	height = 72*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
}

states[S_S3INSTASHIELD] = {SPR_S3IS, 0|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_S3INSTASHIELD1}
states[S_S3INSTASHIELD1] = {SPR_S3IS, 1|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_S3INSTASHIELD2}
states[S_S3INSTASHIELD2] = {SPR_S3IS, 2|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_S3INSTASHIELD3}
states[S_S3INSTASHIELD3] = {SPR_S3IS, 3|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_S3INSTASHIELD4}
states[S_S3INSTASHIELD4] = {SPR_S3IS, 4|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_S3INSTASHIELD5}
states[S_S3INSTASHIELD5] = {SPR_S3IS, 5|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_NULL}

addHook("PlayerSpawn", function(player)
		player.slamstate = 0
		player.spinangle = 0
		player.instad = false
		player.spinjumping = false
		player.mo.walljumps = 0
end)

local spinangle = 0

sfxinfo[sfx_ptstsl].caption = "Groundslam Starting"
sfxinfo[sfx_ptslam].caption = 'Groundslam'
sfxinfo[sfx_swsjmp].caption = 'Spinjump'
sfxinfo[sfx_kswtch].caption = 'Mode Switch'
sfxinfo[sfx_kmspin].caption = 'Boosted Spinjump'
sfxinfo[sfx_kmwkik].caption = 'Wallkick'
sfxinfo[sfx_m64unh].caption = '"Unh!"'
sfxinfo[sfx_m64doh].caption = '"D\'oh!"'
sfxinfo[sfx_m64oof].caption = '"Oof!"'
sfxinfo[sfx_kmbip0].caption = '"Eh..!"'
sfxinfo[sfx_kmbip1].caption = '"Hup!"'

addHook("AbilitySpecial", function(player)
	if player.kombimode == 1 then return end
	if player.mo.collidewall and srb2p then return false end
		if not (player.valid and player.mo and player.mo.valid) then return end
		if (player.mo.skin != "kombi") then return end
		
		if not (player.pflags & PF_THOKKED)
			player.pflags = $|PF_THOKKED
			if not srb2p
				player.powers[pw_strong] = STR_STOMP|STR_ANIM
			end
			player.spinjumping = true
			player.mo.state = S_PLAY_SPINJUMP
			if not (player.powers[pw_shield] & SH_ARMAGEDDON == 2)
				P_SetObjectMomZ(player.mo, 12*FRACUNIT, ((player.mo.momz*(((player.mo.eflags & MFE_VERTICALFLIP) * 2) - 1)) <= 0)) -- I don't trust order of operations that much sorgy
				S_StartSound(player.mo,sfx_swsjmp)
			else
				P_SetObjectMomZ(player.mo, 20*FRACUNIT, ((player.mo.momz*(((player.mo.eflags & MFE_VERTICALFLIP) * 2) - 1)) <= 0))
				S_StartSound(player.mo,sfx_kmspin)
			end
		else
			if player.mo.state == S_PLAY_SPINJUMP
			player.slamstate = 1
			player.mo.momx = $/2
			player.mo.momy = $/2
			P_SetObjectMomZ(player.mo, 5*FRACUNIT, false)
			player.mo.state = S_PLAY_ROLL
			player.spinjumping = false
			S_StartSound(player.mo,sfx_ptstsl)
			end
		end
	return true
end)

addHook("MobjCollide", function(tm, mo) -- I. HATE. DOORS!!
	if mo.player and mo.player.punching or abs(mo.momx) + abs(mo.momy) >= 35*FRACUNIT
		if not mo.valid or not tm.valid then return end
		if not (mo.flags & MF_NOCLIPTHING)
			P_KillMobj(tm, mo, MT_SALOONDOOR)
			mo.storemomx = mo.momx
			mo.storemomy = mo.momy
			mo.storemomz = mo.momz
			mo.pause = 8
			S_StartSound(mo, sfx_wbreak)
		end
	end
end, MT_SALOONDOORCENTER)

addHook("PlayerThink", function(player)
	if not player.mo.pushing
		player.mo.pushing = 0
	else
		player.mo.pushing = $ - 1
	end
	if not player.mo.pause
		player.mo.pause = -35
	end
	if not player.mo.state == S_PLAY_FALL
		player.mo.pushing = 0
	end
	if player.mo.pause
		player.mo.pause = $-1
		player.momx = 0
		player.momy = 0
		player.momz = 0
	elseif player.mo.pause == 0
		player.mo.pause = -35
		player.momx = player.storemomx
		player.momy = player.storemomy
		player.momz = player.storemomz
	end
	if not (player.valid and player.mo and player.mo.valid) then return end
	if (player.mo.skin != "kombi") then return end
	
	if player.mo.state == S_PLAY_SPINJUMP then
		player.spinangle = player.spinangle + FixedAngle(60*FRACUNIT)
		player.drawangle = player.spinangle
	end
	
	if player.instad == nil
		player.instad = false
	end
	
	if player.slamstate > 0
		if (player.cmd.buttons & BT_SPIN) and not srb2p then P_SetObjectMomZ(player.mo, -1*FRACUNIT, true) end
	end
	
	if player.slamstate == 1 and player.mo.momz <= 0
		player.slamstate = 2
		player.mo.state = S_PLAY_SLAM
		if not srb2p
			player.powers[pw_strong] = STR_BOUNCE
		end
	end
	
	if player.slamstate == 2
		if P_IsObjectOnGround(player.mo)
			player.slamstate = 0
			if (player.cmd.buttons & BT_JUMP)
			player.mo.state = S_PLAY_ROLL
			player.pflags = $|PF_JUMPED
			P_SetObjectMomZ(player.mo, 15*FRACUNIT, false)
			end
			S_StartSound(player.mo,sfx_ptslam)
		end
	end
	if P_IsObjectOnGround(player.mo)
		player.spinjumping = false
		player.instad = false
	end
	if (player.cmd.buttons & BT_CUSTOM3) and not player.weapondelay
		player.kombimode = ($+1)%2
		S_StartSound(player.mo, sfx_kswtch)
		player.weapondelay = 8
	end
	if (player.cmd.buttons & BT_CUSTOM1)
	
	end
end)

addHook("MobjDamage", function(mo,mobj,src,dmg,dmgtype)
	if not (mo and mo.valid) then return end
	if not ((mo.flags & MF_SHOOTABLE) or (mo.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR))) then return end
	
	if not (mobj and mobj.valid) then return end
	if not (mobj.player and mobj.player.valid) then return end
	if mobj.player.pflags & PF_THOKKED >= 1
		mobj.player.pflags = $&~PF_THOKKED
	end
end)

addHook("JumpSpinSpecial", function(player)
	if player.kombimode == 1 and player.mo.skin == "kombi"
		if not (player.valid and player.mo and player.mo.valid) then return true end
			if player.mo.skin == "kombi" and not player.instad
				
				player.instad = true
			end
		return true
	end
end)

addHook("MobjMoveCollide", function(insta, mobj)
	if not (insta.z-FixedMul(18*FRACUNIT, insta.scale) > mobj.z+mobj.height) and not(mobj.z-FixedMul(18*FRACUNIT, insta.scale) > insta.z+insta.height)
		if (mobj.valid and (mobj.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR) or (mobj.flags & MF_PUSHABLE and mobj.flags & MF_SHOOTABLE))) and not (mobj.flags2 & MF2_FRET) and (insta.target.player.pflags & PF_JUMPED)
			P_DamageMobj(mobj, insta, insta.target)
			insta.target.player.canbust = 2
			if P_MobjFlip(insta.target)*insta.target.momz < 0
				insta.target.momz = -$
			end
			if (mobj.info.spawnhealth > 1)
				insta.target.momy = -$
				insta.target.momx = -$
			end
		end
	end
end, MT_S3INSTASHIELD)

rawset(_G, "cv_kombiwallkicktype", CV_RegisterVar({
	name = "k_instantwallkick",
	defaultvalue = "Off",
	flags = CV_SAVE|CV_SHOWMODIF,
	PossibleValue = {On = 1, Off = 0},
}))

rawset(_G, "cv_kombibonkers", CV_RegisterVar({
	name = "k_bonking",
	defaultvalue = "Off",
	flags = CV_SAVE|CV_SHOWMODIF,
	PossibleValue = {On = 1, Off = 0},
}))

/// Ability: Wall-Jump
// allows you to cling to walls, and leap off of them

// CUSTOMIZE SECTION START
local skin = "kombi" // your character here
local thebutton = BT_SPIN // the button needed to do the wall jump
if srb2p
	thebutton = BT_JUMP // the button needed to do the wall jump
end
local wallkickheight = 20 // the upwards thrust of the walljump
local wallkickthrust = 15 // the thrust of the wall jump
local sound = sfx_kmwkik // sound of the wall jump
// CUSTOMIZE SECTION END PROCCED BELOW IF YOU KNOW WHAT YOUR DOING

addHook("PlayerThink", function(player)
	if CV_FindVar("k_instantwallkick").string == "Off"
		if player.mo.walljump == nil
			player.mo.walljump = false
		end
		if player.mo.collidewall == nil
			player.mo.collidewall = 0
		end
		if player.mo.collidewall > 0
			player.mo.collidewall = $ - 1
		end
		if P_IsObjectOnGround(player.mo)
			player.mo.walljumps = 0
		end
		if player.kombimode == 0 and player.mo and player.mo.skin == skin
		and (player.cmd.buttons & thebutton)
		and not P_IsObjectOnGround(player.mo)
		and player.mo.collidewall
		and not player.mo.walljump
			player.mo.walljump = true
			player.mo.state = S_PLAY_CLING
			player.pflags = $|PF_FULLSTASIS
			P_SpawnSkidDust(player, player.mo.radius, false)
			S_StartSound(player.mo, sfx_kwskid)
			P_SetObjectMomZ(player.mo, 0)
		end
		if player.mo.walljump == true
		and player.mo.collidewall
			player.mo.state = S_PLAY_CLING
			player.pflags = $|PF_FULLSTASIS
			player.pflags = $ & ~PF_GLIDING
			P_SpawnSkidDust(player, player.mo.radius, false)
			S_StartSound(player.mo, sfx_kwskid)
			P_SetObjectMomZ(player.mo, -2*FRACUNIT)
		end
		if player.mo and player.mo.skin == skin
		and not (player.cmd.buttons & thebutton)
		and not P_IsObjectOnGround(player.mo)
		and player.mo.walljump == true
		and player.mo.collidewall
			player.mo.walljump = false
			player.mo.collidewall = 0
			player.mo.angle = $ + ANGLE_180
			player.drawangle = player.mo.angle
			P_InstaThrust(player.mo, player.mo.angle, wallkickthrust*FRACUNIT)
			if player.mo.walljumps > 4
				P_SetObjectMomZ(player.mo, FixedDiv(wallkickheight*FRACUNIT, max((player.mo.walljumps - 4)*FRACUNIT, FRACUNIT)))
			else		
				P_SetObjectMomZ(player.mo, wallkickheight*FRACUNIT)
			end
			if player.mo.walljumps == 0 and (player.pflags & PF_THOKKED)
				player.pflags = $&~PF_THOKKED
			end
			S_StartSound(player.mo, sound)
			player.mo.walljumps = $ + 1
			player.mo.state = S_PLAY_ROLL
			player.pflags = $|PF_JUMPED
		end
		if player.mo.walljump == true
		and player.mo.collidewall == 0
		and not (player.cmd.buttons & thebutton)
		and not P_IsObjectOnGround(player.mo)
			player.mo.walljump = false
			player.mo.state = S_PLAY_FALL
			player.pflags = $1 & ~PF_FULLSTASIS
		end
	else
		if player.mo.collidewall == nil
			player.mo.collidewall = 0
		end
		if player.mo.collidewall > 0
			player.mo.collidewall = $ - 1
		end
		if P_IsObjectOnGround(player.mo)
			player.mo.walljumps = 0
		end
		if player.mo and player.mo.skin == skin
		and (player.cmd.buttons & thebutton)
		and not P_IsObjectOnGround(player.mo)
		and player.mo.collidewall
			player.mo.walljump = false
			player.mo.collidewall = 0
			player.mo.angle = $ + ANGLE_180
			player.drawangle = player.mo.angle
			P_InstaThrust(player.mo, player.mo.angle, wallkickthrust*FRACUNIT)
			if player.mo.walljumps > 4
				P_SetObjectMomZ(player.mo, FixedDiv(wallkickheight*FRACUNIT, (player.mo.walljumps - 4)*FRACUNIT))
			else		
				P_SetObjectMomZ(player.mo, wallkickheight*FRACUNIT)
			end
			if player.mo.walljumps == 0 and (player.pflags & PF_THOKKED)
				player.pflags = $&~PF_THOKKED
			end
			S_StartSound(player.mo, sound)
			player.mo.walljumps = $ + 1
			player.mo.state = S_PLAY_ROLL
			player.pflags = $|PF_JUMPED
		end
	end
end)

addHook("MobjMoveBlocked", function(mo,mobj,line)
	if mo.skin == skin and not P_IsObjectOnGround(mo)
	and not (mobj and mobj.valid and mobj.flags & (MF_MONITOR|MF_ENEMY|MF_BOSS))
		if PTR_GlideClimbTraverse(mo,line)
		and mo.player and mo.player.valid
			local real,ang = PTR_GlideClimbTraverse(mo,line)
			if line and line.valid
				if (P_IsClimbingValid(mo.player,ang) or (mobj and mobj.valid))
					if mobj and mobj.valid then end
					mo.collidewall = 10
				end
			end
		elseif mobj and mobj.valid
			mo.collidewall = 10
		end
	end
end, MT_PLAYER)

addHook("MobjMoveBlocked", function(mo,mobj,line)
	if mo.skin == skin and not P_IsObjectOnGround(mo) and PTR_GlideClimbTraverse(mo,line)
		if abs(mo.momx) + abs(mo.momy) >= 20*FRACUNIT+FRACUNIT/4 and cv_kombibonkers.string == "On"
			if abs(mo.momx) + abs(mo.momy) >= 32*FRACUNIT
				S_StartSound(mo, sfx_m64doh)
				mo.state = S_PLAY_PAIN
			else
				S_StartSound(mo, sfx_m64unh)
				mo.state = S_PLAY_FALL
			end
			P_InstaThrust(mo, mo.angle, -4*FRACUNIT)
		end
	elseif mo.skin == skin and PTR_GlideClimbTraverse(mo,line)
		if mo.pushing >= 10
			if mo.pushing == 10
				S_StartSound(mo, P_RandomRange(sfx_kmbip0,sfx_kmbip1))
			end
			mo.state = S_PLAY_FALL
		end
		mo.pushing = $ + 2
	end
end, MT_PLAYER)